<template>
  <v-container>
    <v-form ref="referenceFilterForm" fast-fail @submit.prevent="submitForm" class="custom">
      <v-row style="margin-left: 15px">
        <v-col class="v-col" cols="12" md="1">
          <v-checkbox v-model="treteSelected" label-position="left" color="success" hide-details>
            <span style="margin-left: 10px;">Trete</span>
          </v-checkbox>
        </v-col>
        <v-col class="v-col" cols="12" md="2">
          <v-checkbox v-model="allSelected" label-position="left" color="success" hide-details>
            <span style="margin-left: 10px;">Hepsi</span>
          </v-checkbox>
        </v-col>
      </v-row>
      <v-row v-if="treteSelected">
        <v-col>
          <div class="custom-label">Reasürör Şirket</div>
          <br>
          <v-combobox class="custom-combobox" :items="this.reasurorCompanys"
            v-model="reactTreteForm.selectedReasurorCompany" variant="outlined" />
        </v-col>
        <v-col>
          <div class="custom-label">Yıl</div>
          <br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactTreteForm.year"
            type="number" />
          <div class="custom-label">Çeyrek</div>
          <br>
          <v-combobox class="custom-combobox" :items="this.quarters" v-model="reactTreteForm.selectedQuarter"
            variant="outlined" />
        </v-col>
        <v-col>
          <div class="custom-label">Döviz</div>
          <br>
          <v-combobox class="custom-combobox" :items="this.currencies" v-model="reactTreteForm.selectedCurreny"
            variant="outlined" />
          <div class="custom-label">Vade Tarih</div>
          <br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactTreteForm.expiryDate"
            type="date" />
        </v-col>
      </v-row>
      <v-row v-if="allSelected">

        <v-col>
          <div class="custom-label">İşlem Tarihi</div>
          <div style="margin: 0 15px 17px 15px"><VueDatePicker :enable-time-picker="false" v-model="date" range model-type="dd.MM.yyyy" /></div>
          <div class="custom-label">Durum</div>
          <br>
          <v-combobox class="custom-combobox" :items="this.reasurorCompanys"
            v-model="reactAllForm.selectedReasurorCompany" variant="outlined" />
          <div class="custom-label">Reasürör Şirket</div>
          <br>
          <v-combobox class="custom-combobox" :items="this.reasurorCompanys"
            v-model="reactAllForm.selectedReasurorCompany" variant="outlined" />
        </v-col>

        <v-col>
          <div class="custom-label">Yıl</div>
          <br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactAllForm.year"
            type="number" />
          <div class="custom-label">Çeyrek</div>
          <br>
          <v-combobox class="custom-combobox" :items="this.quarters" v-model="reactAllForm.selectedQuarter"
            variant="outlined" />
          <div class="custom-label">Referans No</div>
          <br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactAllForm.year"
            type="number" />

        </v-col>
        <v-col>
          <div class="custom-label">Tutar</div>
          <br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactAllForm.year"
            type="number" />
          <div class="custom-label">Döviz</div>
          <br>
          <v-combobox class="custom-combobox" :items="this.currencies" v-model="reactAllForm.selectedCurreny"
            variant="outlined" />

          <div class="custom-label">Vade Tarih</div>
          <br>
          <v-date-picker class="text-eureko" v-model="selectedDates" range scrollable />

          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactAllForm.expiryDate"
            type="date" />
        </v-col>

      </v-row>
      <v-row>
        <v-col cols="12" md="12" justify="end" class="text-right">
          <custom-button style="width: 120px;margin-left: 10px" color="danger" size="medium" @click="clearFilterForm"
            val="Temizle" />
          <custom-button style="width: 120px;margin-left: 10px" color="primary" size="medium" @click="filter"
            val="Filtrele" />
        </v-col>
      </v-row>
    </v-form>

  </v-container>
</template>
<script>
import CustomButton from "@/components/custom-controller/CustomButton.vue";
import eventBus from '@/plugins/eventBus';
import VueDatePicker from '@vuepic/vue-datepicker';
import '@vuepic/vue-datepicker/dist/main.css'
import { ref, watch } from "vue";


export default {
  components: {
    CustomButton,
    VueDatePicker
  },
  setup() {
    const currencies = ref(["USD", "EUR", "GBP", "JPY", "CAD", "AUD", "CHF", "CNY", "NZD", "ZAR", "RUB", "BRL", "INR", "SGD", "SAR"]);
    const banks = ref(["Akbank", "Garanti BBVA", "Halkbank", "İş Bankası", "Türkiye Cumhuriyeti Ziraat Bankası",
    ]);
    const documentTypeItems = ref(['Banka Dekontu', 'Banka Faturas']);
    const reasurorCompanys = ref(["reasurorCompanys", "reasurorCompanys"])
    const quarters = ref(["quarters", "quarters"])
    const processTypes = ref(["processTypes", "processTypes"])
    const processDetailTypeS = ref(["processDetailTypeS", "processDetailTypeS"])
    const treteSelected = ref(false);
    const allSelected = ref(true);
    const date = ref(null);

    const reactTreteForm = ref({
      selectedProcessType: "",
      selectedReasurorCompany: "",
      year: new Date().getFullYear().toString(),
      selectedQuarter: "",
      selectedCurreny: "",
      expiryDate: new Date().toISOString().substr(0, 10),
    });

    const reactAllForm = ref({
      selectedProcessType: "",
      selecteProcessDetailType: "",
      selectedReasurorCompany: "",
      insured: "",
      year: new Date().getFullYear().toString(),
      selectedQuarter: "",
      damagePolicyNumber: "",
      expiryDate: new Date().toISOString().substr(0, 10),
      issueDate: new Date().toISOString().substr(0, 10)
    });

    const filter = () => {
      console.log(reactAllForm.value);

      if (treteSelected.value) {
        eventBus.emit('reference-process-type', 'treteSelected');
      } else if (allSelected.value) {
        eventBus.emit('reference-process-type', 'allSelected');
      }
    };
    const clearFilterForm = () => {
      this.$refs.referenceFilterForm.reset();

    }
    watch(treteSelected, (newValue) => {
      if (newValue) {
        allSelected.value = false;
      }
    });
    watch(allSelected, (newValue) => {
      if (newValue) {
        treteSelected.value = false;
      }
    });

    return {
      date,
      currencies,
      banks,
      documentTypeItems,
      reasurorCompanys,
      quarters,
      processTypes,
      processDetailTypeS,
      reactTreteForm,
      reactAllForm,
      treteSelected,
      allSelected,
      clearFilterForm,
      filter,

    };
  },
}

</script>
<style  scoped>
@import "@/assets/styles/custom/custom-input.css";
</style>